:- module(sq_prolog, [squares_prolog/3]).

:- use_module(library(lists)).

squares_prolog(Ss, Size, SXYs) :-
        MSize is -Size,
        squares(Ss, [MSize/Size,Size/0], Size, SXYs).

squares([], _, _, [])  :- !.
squares(Ss0, L0, Size, SXYs) :-
        L0=[V0/_|_], Y0 is Size+1+V0,
        hole(L0, 1-Y0, XY, L1, L1T, L2),
        fill_hole(L2, L1T, XY, Size, Ss0, Ss, SXYs1, SXYs),
        squares(Ss, L1, Size, SXYs1).

fill_hole([V0/0,V/H|L], [V1/H|L], _XY, _Size, 
                       Ss0, Ss0, SXYs0, SXYs0) :- 
        !, V1 is  V0+V.
fill_hole([V/H|L0], [V1/S|L1], X-Y, Size,  Ss0, Ss,
                       SXYs0, [s(S,X,Y)|SXYs]) :-
%       MaxS is min(H, Size+1-Y),
%	select(S, Ss0, Ss1), S =< MaxS,
%	myselect(S, Ss0, Ss1), S =< MaxS,
	MaxS1 is min(H, Size+1-Y)+1,
	select_less(S, MaxS1, Ss0, Ss1),
        V1 is V+S, MS is -S, H1 is H-S, X1 is X+S, 
        fill_hole([MS/H1|L0], L1, X1-Y, Size, Ss1, Ss, SXYs0, SXYs).

hole([V1/0,V2/H|L], XY0, XY, L1, L1T, L2) :-
        !, V is V1+V2,
        hole([V/H|L], XY0, XY, L1, L1T, L2).
hole([V/H1,0/H2|L], XY0, XY, L1, L1T, L2) :-
        !, H is H1+H2,
        hole([V/H|L], XY0, XY, L1, L1T, L2).
hole([V1/H1|L], XY, XY, L1, L1, [V1/H1|L]) :-
        H1 > 0, V1 < 0, L = [V2/_|_], V2>0, !.
hole([VH1,VH2|L], X0-Y0, XY, [VH1|L1], L1T, L2) :-
        VH1=_/H1, VH2=V2/_, X1 is X0+H1, Y1 is Y0+V2,
        hole([VH2|L], X1-Y1, XY, L1, L1T, L2).


select_less(S, Mx, [S0|Ss0], [S0|Ss1]) :-
	S0 >= Mx, !,
	select_less(S, Mx, Ss0, Ss1).
select_less(S, _Mx, [S|Ss], Ss). /* S < Mx */
select_less(S, _Mx, [S0|Ss0], [S0|Ss1]) :-
%	bb_get(user:count,C), C1 is C+1, bb_put(user:count,C1),
	select_less(S, S0, Ss0, Ss1).

myselect(S, [S|Ss0], Ss0).
myselect(S, [S0|Ss0], [S0|Ss1]) :-
	bb_get(user:count,C), C1 is C+1, bb_put(user:count,C1),
	myselect(S, Ss0, Ss1).
